{% extends "crud.html" %}


{% block top_records_navigation %}
    <div class="col"></div>
{% endblock %}


{% block add_form %}
    <div class="row">
        <div class="col-12 col-md-6">
            <div class="row">
                <div class="col-12">
                    <div class="form-group">
                        <label>{{ "username"|normalize|title }}*</label>
                        <input type="text" name="username" class="form-control" required maxlength="255" />
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col-12">
                    <div class="form-group">
                        <label>{{ "password"|normalize|title }}*</label>
                        <input type="text" name="password" class="form-control" required maxlength="75" />
                        <a href="#" class="float-right" data-users-toggle="generate_password"><i class="fa fa-fw fa-random"></i> Generate Password</a>
                        <input type="hidden" name="reset_password" />
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col-12">
                    <div class="form-group">
                        <label>{{ "access_level"|normalize|title }}*</label>
                        <select name="access_levels" class="form-control" data-ajax-select-target="/api/v1/acls/all?fields=name,department" data-ajax-select-value="_id" data-ajax-select-label="name,department" required placeholder="-- Select Access Level --">
                            <option value="">-- Select Access Level --</option>
                        </select>
                    </div>
                </div>
            </div>
        </div>
        <div class="col-12 col-md-6">
            <div class="row">
                <div class="col-12">
                    <div class="form-group">
                        <label>{{ "first_name"|normalize|title }}*</label>
                        <input type="text" name="first_name" class="form-control" required maxlength="255" />
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col-12">
                    <div class="form-group">
                        <label>{{ "last_name"|normalize|title }}*</label>
                        <input type="text" name="last_name" class="form-control" required maxlength="255" />
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col-12">
                    <div class="form-group">
                        <label>{{ "gender"|normalize|title }}*</label>
                        <select name="gender" class="form-control" required>
                            <option value="">-- Select Gender --</option>
                            <option value="male">Male</option>
                            <option value="female">Female</option>
                        </select>
                    </div>
                </div>
            </div>
            <hr />
            <div class="row">
                <div class="col-12">
                    <div class="form-group">
                        <label>{{ "email_address"|normalize|title }}</label>
                        <input type="email" name="email" class="form-control" maxlength="255" />
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col-12">
                    <div class="form-group">
                        <label>{{ "primary_contact_number"|normalize|title }}</label>
                        <input type="text" name="primary_contact_number" class="form-control" maxlength="255" />
                    </div>
                </div>
            </div>
        </div>
    </div>
{% endblock %}


{% block empty_spiel %}

{% endblock %}


{% block read_columns %}
{# <script> #}
    {
        data: 'username',
        render: function(data) {
            return '<a href="#" data-crud-toggle="details" class="font-weight-bold" aria-expanded="true"> {0}</a>'.format(data);
        }
    },
    {
        data: 'first_name'
    },
    {
        data: 'last_name'
    },
    {
        data: 'access_levels',
        render: function(data) {
            return '{0} - {1}'.format(data.name, data.department);
        }
    },
    {
        data: 'primary_contact_number',
        render: function(data) {
            return (isDefined(data)) ? data : '';
        }
    },
    {
        data: 'date_created'
    },
    {
        data: '_id',
        sortable: false,
        className: 'text-center',
        render: function(data, type, row) {
            if (row.status === 1) {
                return '<a href="#" class="btn btn-secondary btn-sm btn-block" data-users-toggle="reset_password" data-reset-target="{0}"><i class="fa fa-fw fa-redo"></i> Reset Password</a>'.format(data);
            } else {
                return '';
            }
        }
    },
    {
        data: 'status',
        sortable: false,
        className: 'text-center',
        render: function(data, type, row) {
            switch (data) {
                case 0:
                    return '<a href="#" class="btn btn-success btn-sm btn-block" data-users-toggle="activate" data-activate-target="{0}"><i class="fa fa-unlock fa-fw"></i> Activate</a>'.format(row._id);
                case 1:
                    return '<a href="#" class="btn btn-danger btn-sm btn-block" data-users-toggle="deactivate" data-deactivate-target="{0}"><i class="fa fa-lock fa-fw"></i> Deactivate</a>'.format(row._id);
                default:
                    return '';
            }
        }
    }
{# </script> #}
{% endblock %}


{% block sub_scripts %}
{# <script> #}
    function generate_alphanum(length) {
        let result = '';
        if (!isDefined(length)) {
            length = 8;
        } else if (length > 255) {
            length = 255;
        }
        let chars = 'atuvK12bcdewPQRSTUVfFGHIJopq7xyzAhijklmnWXr456YZ890s3BCDELMNOg';
        for (var i =0; i < length; i++) {
            result += chars.charAt(Math.floor(Math.random() * chars.length));
        }
        return result;
    }

    $dom.document.on('click', '[data-users-toggle="generate_password"]', function() {
        let crud = $(this).closest('[data-crud]').attr('data-crud');
        let password = generate_alphanum();
        $('[data-crud="{0}"] form [name="password"]'.format(crud)).val(password);
        $('[data-crud="{0}"] form [name="reset_password"]'.format(crud)).val(true);
        Swal.fire('Password Generated', password, 'success');
    });

    $dom.document.on('click', '[data-users-toggle="reset_password"]', function() {
        let $self = $(this);
        Swal.fire({
            type: 'question',
            title: 'Reset Password?',
            text: 'User will be prompt to change password upon Login',
            showCancelButton: true,
            focusCancel: true,
            confirmButtonText: 'Yes'
        }).then((result) => {
            if (result.value) {
                let crud = $(this).closest('[data-crud]').attr('data-crud');
                let password = generate_alphanum();
                $.post('{{ url_for(".reset_password", _id="placeholder") }}'.replace('placeholder', $self.attr('data-reset-target')), {'password': password}, function() {})
                .done(function(response) {
                    if (isDefined(response.success) && response.success) {
                        Swal.fire('Password Reset', password, 'success');
                    }
                    else {
                        Swal.fire('Error', response.error, 'error');
                    }
                })
                .always(function() {
                })
                .fail(function() {
                    Swal.fire('Error', 'Server Error', 'error');
                });
            }
        });
    });

    $dom.document.on('click', '[data-users-toggle="activate"]', function() {
        let $self = $(this);
        Swal.fire({
            type: 'question',
            title: 'Activate User?',
            text: 'User will be able to Login again',
            showCancelButton: true,
            focusCancel: true,
            confirmButtonText: 'Yes'
        }).then((result) => {
            if (result.value) {
                $.post('{{ url_for(".change_status", _id="placeholder") }}'.replace('placeholder', $self.attr('data-activate-target')), {'status': 1}, function() {})
                .done(function(response) {
                    if (isDefined(response.success) && response.success) {
                        Swal.fire('User Successfully Activated', '', 'success');
                    }
                    else {
                        Swal.fire('Error', response.error, 'error');
                    }
                })
                .always(function() {
                    $dom.datatables.records.reload('activate user');
                })
                .fail(function() {
                    Swal.fire('Error', 'Server Error', 'error');
                });
            }
        });
    });

    $dom.document.on('click', '[data-users-toggle="deactivate"]', function() {
        let $self = $(this);
        Swal.fire({
            type: 'question',
            title: 'Deactivate User?',
            text: 'User will be unable to Login upon success',
            showCancelButton: true,
            focusCancel: true,
            confirmButtonText: 'Yes'
        }).then((result) => {
            if (result.value) {
                $.post('{{ url_for(".change_status", _id="placeholder") }}'.replace('placeholder', $self.attr('data-deactivate-target')), {'status': 0}, function() {})
                .done(function(response) {
                    if (isDefined(response.success) && response.success) {
                        Swal.fire('User Successfully Deactivated', '', 'success');
                    }
                    else {
                        Swal.fire('Error', response.error, 'error');
                    }
                })
                .always(function() {
                    $dom.datatables.records.reload('deactivate user');
                })
                .fail(function() {
                    Swal.fire('Error', 'Server Error', 'error');
                });
            }
        });
    });

    $dom.document.on('keyup mouseup input', 'input[name="password"]', function() {
        if ($(this).val() !== '') {
            let crud = $(this).closest('[data-crud]').attr('data-crud');
            $(this).closest('.form-group').find('[type="hidden"][name="reset_password"]').val(false);
        } else {
            $(this).closest('.form-group').find('[type="hidden"][name="reset_password"]').val(true);
        }
    });
{# </script> #}
{% endblock %}
